#ifndef __VV_CLOUD_SDK_H__
#define __VV_CLOUD_SDK_H__
//#include "stdafx.h"


//error
#define PLAT_ERROR_WAIT					202	//ʱҪȴ	ȴ
#define PLAT_ERROR_FAIL_VERIFICATION	203	//֤	ȡúϷʸ
#define PLAT_ERROR_DEVICE_UNINIT		204	//豸δʼ	ڿͻ˽豸
#define PLAT_ERROR_DEVICE_NOT_SURPPORT	205	//豸ֵ֧Ĳ	
#define PLAT_ERROR_REQUEST_FAIL			400	//ʧ	
#define PLAT_ERROR_NEED_PAY				402	//Ҫ	
#define PLAT_ERROR_NOT_ALLOWD			403	//ֹ	ѱãϵԱ¿ͨ
#define PLAT_ERROR_HAVENOT_RESOURCE		404	//ԴҲ	
#define PLAT_ERROR_HAVENOT_AUTHORITY	405	//δȨ	ûȨ޲
#define PLAT_ERROR_NOT_ALLOW_OPERATE	406	//ֹ	繲鲻ܱ޸
#define PLAT_ERROR_DEVICE_NOT_REGIRST	407	//豸δ	δ豸а󶨵Ȳ
#define PLAT_ERROR_TIMESTAMP			408 //ʱ	ͻ
#define PLAT_ERROR_SYN					410	//ͬͻ	޸ĵԴѱ޸
#define PLAT_ERROR_USER_ILLEGAL			411	//ûϷ	ָûʽȷܱע
#define PLAT_ERROR_WRONG_USERACCOUT		412	//ûڻ	ڰ󶨲ʱ󶨵ûڻ趨
#define PLAT_ERROR_DEVICE_SERVICE		413	//豸쳣	޷豸onvif񣬼豸
#define PLAT_ERROR_DEVICE_USERACCOUT	414	//豸	豸˺޸˺
#define PLAT_ERROR_DEVICE_HAVENOT_AUTHORITY 415	//豸Ȩ	ָĲʹõ豸˺޴Ȩ 
#define PLAT_ERROR_DEVICE_PASSWORD_ILLEGAL	416	//豸ʽȷ	޸豸ʱʽȷ
#define PLAT_ERROR_REQUEST_FORMAT			500	//ڲ	Ϣʽ
#define PLAT_ERROR_PROGRAM					501	//ϵͳڲ	򼶴ڴʧܵ
#define PLAT_ERROR_DEVICE_CONNECT_SERVICE	502	//豸޷ʷʷ	豸Ƿ
#define PLAT_ERROR_CONNECT_SERVICE_TIMEOUT  503	//ʷʱ	
#define PLAT_ERROR_SERVICE_ROOT				504	//޷	

#define PLAT_OK								0
#define PLAT_ERROR_BUILD_MSG				-2
#define PLAT_ERROR_POST_FAIL				-3
#define PLAT_ERROR_SERVER_MSG_BACK_FAIL		-4
#define PLAT_ERROR_HAVENOT_ACCESS_URL		-5
#define PLAT_UNINIT							-6

void  WINAPI vv_cloud_free(long cloud_handle,char* pdata);
long  WINAPI vv_cloud_init(char* serverurl, char* app_key, char* key);
long  WINAPI vv_cloud_initv2(char* serverip, int port, char* app_key, char* key);

void  WINAPI vv_cloud_uninit(long cloud_handle);
int   WINAPI vv_cloud_login(long cloud_handle, char* user, char* pass);
void  WINAPI vv_cloud_loginout(long cloud_handle);
char* WINAPI vv_cloud_get_client_access_url(long cloud_handle);
char* WINAPI vv_cloud_get_device_access_url(long cloud_handle);
int  WINAPI vv_cloud_user_check(long cloud_handle,char* user);
int  WINAPI vv_cloud_get_regverify_type(long cloud_handle,int* out_veryfy_type);
int  WINAPI vv_cloud_get_pic_vcode(long cloud_handle,char** out_pic, int* out_size);
int  WINAPI vv_cloud_pic_vcode_check(long cloud_handle,char* vcode);
int  WINAPI vv_cloud_get_sms_vcode(long cloud_handle,char* mobile, int checkexist);
int  WINAPI vv_cloud_sms_vcode_check(long cloud_handle,char* mobile, char* vcode);
int  WINAPI vv_cloud_user_regist(long cloud_handle,char* user, char* pass, char* vcode, char* nick, char* email, char* mobile);
int  WINAPI vv_cloud_user_modify_pass(long cloud_handle,char* oldpass, char* newpass);
int  WINAPI vv_cloud_user_resetpass_email(long cloud_handle,char* user, char* vcode);
int  WINAPI vv_cloud_user_resetpass_sms(long cloud_handle,char* mobile, char* vcode, char* new_pass);
int  WINAPI vv_cloud_get_camlist_sn(long cloud_handle,int* out_sn);
int  WINAPI vv_cloud_get_dev_list(long cloud_handle,char** out_devlist);
int  WINAPI vv_cloud_get_cam_list(long cloud_handle,char** out_camlist);
int  WINAPI vv_cloud_get_cam_pic(long cloud_handle,char* cam_id, char** out_pic, int* out_size);
int  WINAPI vv_cloud_rename_cam(long cloud_handle,const char* cam_id, const char* cam_name);
int  WINAPI vv_cloud_move_cams(long cloud_handle, char* cam_id, char* to_group_id);
int  WINAPI vv_cloud_new_group(long cloud_handle,char* group_name, char* to_group_id, char** out_new_group_id);
int  WINAPI vv_cloud_rename_group(long cloud_handle,const char* group_id, const char* group_name);
int  WINAPI vv_cloud_move_group(long cloud_handle,char* group_id, char* to_group_id);
int  WINAPI vv_cloud_remove_group(long cloud_handle,char* group_id);
int  WINAPI vv_cloud_remove_dev(long cloud_handle,char* dev_id);
int  WINAPI vv_cloud_get_unread_event_count(long cloud_handle,int* out_unread_count);
int  WINAPI vv_cloud_get_new_event_list( long cloud_handle,char* event_id, char** out_event_list);
int  WINAPI vv_cloud_get_event_list(long cloud_handle, char* event_id, int items_count, char** out_event_list);
int  WINAPI vv_cloud_get_event_pic(long cloud_handle, char* event_id, char** out_pic, int* out_size);
int  WINAPI vv_cloud_set_all_events_readed(long cloud_handle);
int  WINAPI vv_cloud_get_cam_new_event_list(long cloud_handle, char* cam_id, char* event_id, char** out_event_list);
int  WINAPI vv_cloud_get_cam_event_list(long cloud_handle,char* cam_id, char* event_id, int items_count, char** out_event_list);
int  WINAPI vv_cloud_get_event_pic_url(long cloud_handle,char* event_id, char* out_url);
int  WINAPI vv_cloud_get_cam_alert_status(long cloud_handle,char* dev_id, char* cam_id, char** out_alert_status);
int  WINAPI vv_cloud_set_cam_alert_status(long cloud_handle,char* dev_id, char* cam_id, int alert_staus,  char** out_alert_status);
int  WINAPI vv_cloud_post_bind_dev(long cloud_handle,char* dev_id, char* dev_user, char* dev_pass, char* model, char* firmware, char* channels);
int  WINAPI vv_cloud_get_userinfo(long cloud_handle,char* user,  char** out_json);
int	 WINAPI vv_cloud_user_modify_email(long cloud_handle,const char* user, const char* pass, const char* email);
int  WINAPI vv_cloud_add_user_relation(long cloud_handle,const char* user, const char* pass, char*relation_user, int relation_type);
int  WINAPI vv_cloud_disable_cam_alert_event(long cloud_handle,const char* user, const char* pass,const char* dev_id, const char* cam_id);
int  WINAPI vv_cloud_disable_share_cam(long cloud_handle, const char* user, const char* pass,  const char* cam_id, const char*  dev_id);
int  WINAPI vv_cloud_enable_share_cam(long cloud_handle,const char* user, const char* pass, const char* relation_user, const char* cam_id);
int  WINAPI vv_cloud_get_cam_share_list(long cloud_handle,const char* user, const char* pass,const char* relation_user, char** out_json);
int  WINAPI vv_cloud_get_cam_share_req_count(long cloud_handle, const char* user, const char* pass, int* share_req_count);
int  WINAPI vv_cloud_get_cam_share_req_list(long cloud_handle, const char* user, const char* pass, char** out_json);
int  WINAPI vv_cloud_get_cam_shared_userlist(long cloud_handle,const char* user, const char* pass, const char* dev_id, const char* cam_id, char** out_json);
int  WINAPI vv_cloud_get_dev_owner(long cloud_handle, const char* user, const char* pass, const char* dev_id, char** out_json);
int  WINAPI vv_cloud_get_user_relations(long cloud_handle, const char* user, const char* pass, char** out_json);
int  WINAPI vv_cloud_modify_user_relation(long cloud_handle,const char* user, const char* pass, const char* relation_user, int relation_type,const char* memo);
int  WINAPI vv_cloud_remove_user_relation(long cloud_handle,const char* user, const char* pass, char*relation_user);
int  WINAPI vv_cloud_req_dev_share(long cloud_handle, const char* user, const char* pass, const char* dev_id, const char* memo);
int  WINAPI vv_cloud_response_cam_share(long cloud_handle,const char* user, const char* pass, const char* req_id, int cmd);
int  WINAPI vv_cloud_set_cam_share_list(long cloud_handle,const char* user, const char* pass, const char* relation_user, const char* json_list);
int  WINAPI vv_cloud_set_cams_alert_status( long cloud_handle,char* json_list, int alert_staus);
int  WINAPI vv_cloud_user_modify_email(long cloud_handle, const char* user, const char* pass, const char* email);
int  WINAPI vv_cloud_user_modify_nick(long cloud_handle,const char* user, const char* pass, const char* nick);
int  WINAPI vv_cloud_get_dev_firmware_info(long cloud_handle,const char* user, const char* pass,  const char*  dev_id,  char** out_fireware_info);
int  WINAPI vv_cloud_transfer_dev(long cloud_handle,const char* user, const char* pass, const char*  dev_id,  const char* to_user,int retain_shared_info);
int  WINAPI vv_cloud_set_cam_private_status(long cloud_handle,const char* user, const char* pass,  const char* cam_id, const char*  dev_id, int priv_mode, int status);
int  WINAPI vv_cloud_disable_cam_low_power(long cloud_handle,const char* user, const char* pass,  const char* cam_id, const char*  dev_id);
int  WINAPI vv_cloud_move_cam_to_new_group(long cloud_handle, const char* new_group_name, const char* new_group_parent, const char* move_cam_id, char** out_json_new_group_id);
int  WINAPI vv_cloud_move_group_to_new_group(long cloud_handle, const char* new_group_name, const char* new_group_parent, const char* move_group_id, char** out_json_new_group_id);
int  WINAPI vv_cloud_set_cam_shared_userlist(long cloud_handle, const char* cam_id, const char* dev_id, const char* json_users);
int  WINAPI vv_cloud_get_username_by_mobile(long cloud_handle, const char* mobile, char** out_json);
int  WINAPI vv_cloud_get_email_vcode(long cloud_handle,const char* email, int checkexist, const char* lang);
int  WINAPI vv_cloud_user_resetpass_email_v2(long cloud_handle, const char* email);

//for xfjd
int WINAPI vv_cloud_admin_add_user(long cloud_handle, char* add_user, char* add_pass, int user_type, char* nick, char* email, char* mobile, char* group_id);
int WINAPI vv_cloud_admin_bind_cam_modbus(long cloud_handle,   char* modbus_dev_id, char* cam_id);
int WINAPI vv_cloud_admin_cancel_user_dev(long cloud_handle,    const char* dev_id);
int WINAPI vv_cloud_admin_cancel_user_modbus(long cloud_handle,    const char* dev_id);
int WINAPI vv_cloud_admin_get_group_sn(long cloud_handle, int* sn);
int WINAPI vv_cloud_admin_move_group(long cloud_handle,   const char* group_id, const char* to_group_id, char** out_json);
int WINAPI vv_cloud_admin_new_group(long cloud_handle,   const char* group_name, const char* to_group_id, char** out_json);
int WINAPI vv_cloud_admin_remove_cam_modbus(long cloud_handle,    const char* dev_id, const char* cam_id, char** out_json);
int WINAPI vv_cloud_admin_remove_group(long cloud_handle,    const char* group_id);
int WINAPI vv_cloud_admin_rename_cam(long cloud_handle,   const char* cam_id, const char* cam_name);
int WINAPI vv_cloud_admin_rename_group(long cloud_handle,   const char* group_id, const char* group_name);
int WINAPI vv_cloud_admin_rename_modbus_dev(long cloud_handle,   char* dev_id, char* dev_name);
int WINAPI vv_cloud_bind_cam_modbus(long cloud_handle,  char* dev_id, char* cam_id_jsonlist);
int WINAPI vv_cloud_bind_user_modbus(long cloud_handle, char* dev_id, char* protocol);
int WINAPI vv_cloud_distribute_dev_to_user(long cloud_handle,  char* ordinary_user, char* dev_id);
int WINAPI vv_cloud_distribute_modbus_to_user(long cloud_handle,  char* ordinary_user, char* dev_id);
int WINAPI vv_cloud_get_admin_group_list(long cloud_handle, char** json_grouplist);
int WINAPI vv_cloud_get_cam_list_sp(long cloud_handle, int use_sess, char** out_json_list);
int WINAPI vv_cloud_get_cam_list_sessionid(long cloud_handle, char** out_json);
int WINAPI vv_cloud_get_camlist_sn_sp(long cloud_handle, int use_sess, char** out_json);
int WINAPI vv_cloud_get_dev_account_sessionid(long cloud_handle, const char* sessionid, char** out_json);
int WINAPI vv_cloud_get_dev_list_sp(long cloud_handle, int use_sess, char** out_json);
int WINAPI vv_cloud_get_modbus_alarm_list(long cloud_handle,  char* dev_id, char** out_json);
int WINAPI vv_cloud_get_modbus_dev_list(long cloud_handle, char** json_list);
int WINAPI vv_cloud_get_modbus_parameter(long cloud_handle,  char* dev_id, char** out_json);		   
int WINAPI vv_cloud_get_modbus_protocol(long cloud_handle, char** jsonProtocol);
int WINAPI vv_cloud_get_undistributed_dev_list(long cloud_handle, char** json_list);
int WINAPI vv_cloud_get_undistributed_modbus_list(long cloud_handle, char** json_list);
int WINAPI vv_cloud_get_user_cam_list(long cloud_handle, char* ordinary_user, char** out_json);
int WINAPI vv_cloud_get_user_dev_list(long cloud_handle, char* ordinary_user, char** out_json);
int WINAPI vv_cloud_get_user_modbus_list(long cloud_handle, char* ordinary_user, char** out_json);
int WINAPI vv_cloud_get_user_type(long cloud_handle, int* user_type);
int WINAPI vv_cloud_move_modbus_device(long cloud_handle,  char* dev_id, char* to_group_id);
int WINAPI vv_cloud_move_modbus_group(long cloud_handle, char* group_id, char* to_group_id);
int WINAPI vv_cloud_new_modbus_group(long cloud_handle,  char* group_name, char* to_group_id);
int WINAPI vv_cloud_remove_cam_modbus(long cloud_handle,  char* dev_id, char* cam_devid);
int WINAPI vv_cloud_remove_modbus_dev(long cloud_handle,  char* dev_id);
int WINAPI vv_cloud_remove_modbus_group(long cloud_handle, const char* group_id);
int WINAPI vv_cloud_rename_modbus_dev(long cloud_handle,  char* dev_id, char* dev_name);
int WINAPI vv_cloud_rename_modbus_group(long cloud_handle, char* group_id, char* group_name);
int WINAPI vv_cloud_set_cam_list_sp(long cloud_handle, char* cam_list_json, int use_sess);
int WINAPI vv_cloud_set_dev_list_sp(long cloud_handle, char* cam_list_json, int update_sn, int use_sess);
#endif