// CPicCode.cpp : ʵļ
//

#include "stdafx.h"
#include "VVCloudDemo.h"
#include "CPicCode.h"


// CPicCode

IMPLEMENT_DYNAMIC(CPicCode, CStatic)

CPicCode::CPicCode()
{
	m_pBitmap = NULL;
}

CPicCode::~CPicCode()
{
	Empty();
}


BEGIN_MESSAGE_MAP(CPicCode, CStatic)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()



// CPicCode Ϣ




void CPicCode::Empty()
{
	if(m_pBitmap != NULL)
	{
		Status lastStatus = m_pBitmap->GetLastStatus();
		if(lastStatus ==Ok)
		{
			delete m_pBitmap; 
			m_pBitmap = NULL;
		}
	}

	if (m_hBuffer)
	{
		::GlobalUnlock(m_hBuffer);
		::GlobalFree(m_hBuffer);
		m_hBuffer = NULL;
	} 
}


BOOL CPicCode::LoadFromMemery(char* pResourceData, int imageSize)
{
	Empty();
	if (!imageSize)
		return false;

	if (!pResourceData)
		return false;

	m_hBuffer  = ::GlobalAlloc(GMEM_MOVEABLE, imageSize);
	if (m_hBuffer)
	{
		void* pBuffer = ::GlobalLock(m_hBuffer);
		if (pBuffer)
		{
			CopyMemory(pBuffer, pResourceData, imageSize);

			IStream* pStream = NULL;
			if (::CreateStreamOnHGlobal(m_hBuffer, FALSE, &pStream) == S_OK)
			{
				m_pBitmap = Gdiplus::Bitmap::FromStream(pStream);
				pStream->Release();
				if (m_pBitmap)
				{ 
					if (m_pBitmap->GetLastStatus() == Gdiplus::Ok)
						return true;

					delete m_pBitmap;
					m_pBitmap = NULL;
				}
			}
			::GlobalUnlock(m_hBuffer);
		}
		::GlobalFree(m_hBuffer);
		m_hBuffer = NULL;
	}

	return false;
}

void CPicCode::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ڴ˴Ϣ
	// ΪͼϢ CStatic::OnPaint()
	CRect rect;
	GetClientRect(rect);
	if(m_pBitmap)
	{
		Graphics graghic(dc.GetSafeHdc());
		graghic.DrawImage(m_pBitmap, Rect(rect.left , rect.top , rect.Width(), rect.Height()),
		0,0,m_pBitmap->GetWidth(),  m_pBitmap->GetHeight()
		,UnitPixel,NULL,NULL,NULL);
	}
	
}

BOOL CPicCode::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ڴϢ/Ĭֵ
	return TRUE;
	return CStatic::OnEraseBkgnd(pDC);
}
